import org.junit.Before;
import org.junit.Test;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;
import javax.xml.xpath.*;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import java.io.IOException;
import java.util.Collection;

import static org.junit.Assert.*;

/**
 * User: Ľuboš Pecho
 * Date: 9.3.2010
 * Time: 21:06:41
 * To change this template use File | Settings | File Templates.
 */
public class CarsHandlerTest {

    private Document document;

    private CarsHandlerImpl carsHandler = new CarsHandlerImpl();
    private XPath xpath;

    @Before
    public void setUp() throws ParserConfigurationException, IOException, SAXException {
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        DocumentBuilder builder = factory.newDocumentBuilder();
        document = builder.parse("cars.xml");
        xpath = XPathFactory.newInstance().newXPath();
    }

    @Test
    public void testGetCarsOlderThan() throws XPathExpressionException {
        NodeList expectedResult = (NodeList)xpath.evaluate(
                "//car[manufactured<2008]", document, XPathConstants.NODESET);
        Collection<Node> result = carsHandler.getAllCarsOlderThan(document, 2008);
        assertEquals(expectedResult.getLength(), result.size());
        for(int i = 0; i < expectedResult.getLength(); i++){
            assertTrue(result.contains(expectedResult.item(i)));
        }
    }

    @Test
    public void testGetAllPetrolCars() throws XPathExpressionException {
        NodeList expectedResult = (NodeList) xpath.evaluate(
                "//car[motor/type = 'petrol']", document, XPathConstants.NODESET);
        Collection<Node> result = carsHandler.getAllPetrolCars(document);
        assertEquals(expectedResult.getLength(), result.size());
        for(int i = 0; i < expectedResult.getLength(); i++){
            assertTrue(result.contains(expectedResult.item(i)));
        }
    }

    @Test
    public void testRemoveHybridCar() throws XPathExpressionException {
        carsHandler.removeHybridCars(document);
        NodeList expectedResult = (NodeList) xpath.evaluate(
                "//car[motor/type = 'hybrid']", document, XPathConstants.NODESET);
        assertEquals(0, expectedResult.getLength());        

    }

}
